/***
 * uGASP location based demonstrator.
 * Copyright (C) 2008 CNAM/INT
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contact: gasp-team@objectweb.org
 *
 * Author: Romain Pellerin
 */
//#include parameters.h
////////////////////////
// Compile params     //
////////////////////////



////////////////////////
// Game params        //
////////////////////////

////#define PING
////#define VIRTUAL_WORLD_MAP

////////////////////////
// Mobile Ajax params //
////////////////////////


////////////////////
// Logging params //
////////////////////

// enable to log in a mobile phone file (Nokia videos folder)
// we used the JSR75 
////#define LOG_FILE 


//#endinclude
package org.ugasp.demonstrator.client.game;

import org.ugasp.demonstrator.NewPlayer;

//#ifdef REAL_WORLD_MAP
import org.ugasp.demonstrator.LocationEvent;
import org.ugasp.demonstrator.MapRequest;
import org.ugasp.demonstrator.MapResponse;
import org.ugasp.demonstrator.PlayerCoordinates;
//#endif REAL_WORLD_MAP

//#ifdef PING
//# import org.ugasp.demonstrator.PingPlayer;
//#endif PING

//#ifdef VIRTUAL_WORLD_MAP
//# import org.ugasp.demonstrator.UpdatePlayer;
//#endif VIRTUAL_WORLD_MAP

import org.ugasp.demonstrator.client.App;
import org.ugasp.demonstrator.client.IHMGasp;
import org.ugasp.demonstrator.client.NetworkCom;


public class SimpleGameCanvas extends GameCanvas {
	
	private HeroeActor heroe;
	
	//#ifdef DEMO
	//# private BallSpitter ballSpitter;
	//#endif DEMO
	
	/**
	 * @param midlet
	 */
	public SimpleGameCanvas(App midlet, IHMGasp ihmGasp, int _time) {
		super(midlet, ihmGasp,_time);
	}

	/*********************************/
	/*** SimpleGame initialization ***/
	/*********************************/

	protected void initializeNewGame() {
		
		if (heroe == null) {
			heroe = new HeroeActor(this);
			
			heroe.username = ihmGasp.pseudoname;
			System.out.println("heroe username: "+heroe.username);
			heroe.longitude_x = this.getWidth()/2;
			heroe.latitude_y = this.getHeight()/2;
			//#ifdef DEMO
			//# ballSpitter = new BallSpitter(this);
			//#endif DEMO
		} else {
			heroe.initialize();
			//#ifdef DEMO
			//# ballSpitter.initialize();
			//#endif DEMO
		}
		
		//#ifdef DEMO
		//# ballSpitter.initializeSpitter(1800000, 500000);
		//#endif DEMO
		
		addActor(heroe);
		//#ifdef DEMO
		//# addActor(ballSpitter);
		//#endif DEMO
		
		sendNewPlayer();
		canUpdate = true;
	}
	/**
	 * This method sends a newPlayer message. It's called by  
	 * initializeNewGame
	 */
	private void sendNewPlayer() {
		NewPlayer np = NetworkCom.newNewPlayerMessage();
		np.setId(ihmGasp.aSID);
		np.setX(heroe.getX());
		np.setY(heroe.getY());
		np.setUsername(heroe.username);
		np.draw();
		System.out.println("Push NewPlayer msg to NetworkCom");
		ihmGasp.sendMessage(np);
		System.out.println("Msg correctly pushed");
	}
	
	/**
	 * this method preloads all the PNG
	 */
	public void initialize() {
				for (int i = 1 ; i <=
				//#ifdef VERSION_SOLO
				//# App.NB_OF_PNGS
				//#else
				//#endif VERSION_SOLO
				GameCanvas.NB_OF_PNGS
				; i++) {
			try{
			ResourcesManager.preloadResource(i , ResourcesManager.PNG);
				}
			catch (Exception e){
				System.out.println(i);
				}
			}
		ResourcesManager.loadEverything();
	}
	
	protected void manageCamera() {
		if (heroe != null) {
			centerOnActorX(heroe);
			centerOnActorY(heroe);
		}
	}

	/***************************/
	/*** Messages management ***/
	/***************************/
	
	/**
	 * This method treats each type of message:
	 * UpdatePlayer, NewPlayer, PingPlayer 
	 */
	public void treatReceivedMessage(Object o) {
		if (o instanceof NewPlayer) {
			try{
				NewPlayer np = (NewPlayer) o;
				np.draw();
				MultiplayerActor ma = new MultiplayerActor(this,np.getId());
				nbMultiplayerActors++;
				ma.username = np.getUsername();
				System.out.println("Player Name:"+np.getUsername());
				ma.x=np.getX();
				ma.y=np.getY();
				//ma.initialize();
				addActor(ma);
				
				
			}catch(NullPointerException ne){
				System.out.println("here");
			}
			finally{
				messagesTreated.addElement(o);
			}
		}
		//#ifdef REAL_WORLD_MAP
		else if (o instanceof LocationEvent){
			try{
				LocationEvent location = (LocationEvent) o;
				
				MultiplayerActor ma = getMultiplayerActor(location.getId());
				
				if (ma!=null){
					ma.longitude_x = location.getProjectedX();
					ma.latitude_y = location.getProjectedY();
					ma.mapCoordsReceived = true;
					System.out.println("Projected position for player "+location.getId()+" : "+ma.longitude_x+"/"+ma.latitude_y);

				}else{
					System.out.println("treatReceivedMessage: player unknown");
				}
			}catch(NullPointerException ne){}
			
			messagesTreated.addElement(o);
		}
		else if (o instanceof MapResponse){
			try{
				// do not treat map response until map is obtained
				// from map provider 
				if (!realWorldMapObtained) return;
				
				MapResponse mapRsp = (MapResponse) o;
				
				for(int i=0; i<mapRsp.getPlayerCoordinates().length; i++){
					PlayerCoordinates playerCoords = mapRsp.getPlayerCoordinates()[i];
	
					MultiplayerActor ma = getMultiplayerActor(playerCoords.getId());
					
					if (ma!=null){
						ma.longitude_x = playerCoords.getX();
						ma.latitude_y = playerCoords.getY();
						ma.mapCoordsReceived = true;
						System.out.println("Projected position for player"+playerCoords.getId()+" : "+ma.longitude_x+"/"+ma.latitude_y);

					}else{
						System.out.println("treatReceivedMessage: player unknown");
					}
				}
				
				
			}catch(NullPointerException ne){}
			
			messagesTreated.addElement(o);
		}
		//#endif REAL_WORLD_MAP
		//#ifdef VIRTUAL_WORLD_MAP
		//# else if (o instanceof UpdatePlayer){
			//# try{
				//# UpdatePlayer updp = (UpdatePlayer) o;
				//# MultiplayerActor ma = getMultiplayerActor(updp.getId());
					//# 
				//# if (ma!=null){
					//# ma.setWantedPosition(updp.getX(), updp.getY());
					//# ma.setWantedPositionSpeeds(updp.getSpeedX(), updp.getSpeedY());
					//# ma.isPositionReached = false;
				//# }else{
				//# /*	System.out.println("Player unknown");*/
					//# }
			//# }catch(NullPointerException ne){
				//# /*System.out.println("here :p");*/
			//# }finally{
					//# messagesTreated.addElement(o);
			//# }
		//# }
		//#endif VIRTUAL_WORLD_MAP
		//#ifdef PING
		//# else if (o instanceof PingPlayer){
			//# try{
				//# PingPlayer pp = (PingPlayer) o;
			//#ifdef DEMO
				//# if (DEBUG) System.out.println("PingPlayer received ("+pp.getId()+","+pp.getPingNum()+")");
			//#endif DEMO
				//# MultiplayerActor ma = getMultiplayerActor(pp.getId());
				//# ma.updatePing(pp.getPingNum(), pp.getSenderAveragePing(), pp.getDesynchronizationWithSender());
			//# }catch(NullPointerException ne){
				//# if (DEBUG) System.out.println("Error from a treatment of ping: null");	
			//# }finally{
					//# messagesTreated.addElement(o);
			//# }
		//# }
		//#endif PING
	}

	public void failed(Throwable th) {
		// TODO Auto-generated method stub
		
	}

	//#ifdef REAL_WORLD_MAP
	public void fix(String utc, double lat, double lon, int nsat,
			double accuracy, double altitude) {
		
		
		
		if (heroe.latitude != lat && heroe.longitude != lon){
			locationChanged = true;
			//mapCenterChanged = true;
		}
		
		heroe.latitude = lat;
		heroe.longitude = lon;
		locationAccuracy = accuracy;
		System.out.println("GPS position fixed: "+lat+"/"+lon);
		
		if (!firstLocationReceived){
			mapRequest();
		}
		
		firstLocationReceived = true;
	}

	private boolean locationChanged = false;
	private boolean firstLocationReceived = false;
	private static LocationEvent location = new LocationEvent();
	private static MapRequest mapReq = new MapRequest();

	public Object updateLocation() {
		if (locationChanged){
			location.setId((short)ihmGasp.aSID);
			location.setLatitude(heroe.latitude);
			location.setLongitude(heroe.longitude);
			
			locationChanged = false;
			return location;
		}
		
		return null;
	}
	
	public void mapRequest(){
		if (heroe.longitude == 0 && heroe.latitude == 0) return;
		
		lockZoomCommand = true;
		realWorldMapObtained = false;
			
		//inform the server about new map request	
		mapReq.setId((short)ihmGasp.aSID);
		mapReq.setZoom((byte)mapZoomLevel);
		mapReq.setWidth(this.getWidth());
		mapReq.setHeight(this.getHeight());
		mapReq.setLatitude(heroe.latitude);
		mapReq.setLongitude(heroe.longitude);
		ihmGasp.sendMessage(mapReq);
		
		//request map from provider (YahooMaps)
		ihmGasp.mapRequest(heroe.latitude, heroe.longitude, mapZoomLevel,this.getWidth(),this.getHeight());
	}
	
	
	//#endif REAL_WORLD_MAP
	
	
	//#ifdef VIRTUAL_WORLD_MAP
	//# private static UpdatePlayer updp = new UpdatePlayer();
	//#endif VIRTUAL_WORLD_MAP
	
	//#ifdef PING
	//# private static PingPlayer pp = new PingPlayer();
	//# public static long lastPingUpdateTime = 0;
	//#endif PING
	
	//#ifdef VIRTUAL_WORLD_MAP
	//# /**
	 //# * This object is used to send in a cyclic way the Update message 
	 //# */
	//# public Object cyclicUpdateMessagesToSend() {
		//# if (canUpdate){
			//# updp.setId(ihmGasp.aSID);
			//# updp.setX(heroe.getX());
			//# updp.setY(heroe.getY());
			//# updp.setSpeedX(heroe.getSpeedX());
			//# updp.setSpeedY(heroe.getSpeedY());
			//# 
			//# canUpdate = false;
			//# return updp;
		//# }
		//# 
		//# else return null;
	//# }
	//#endif VIRTUAL_WORLD_MAP
	
	//#ifdef PING
	//# /**
	 //# * This object is used to send in a cyclic way the PingPlayer message 
	 //# */
	//# public Object cyclicPingPlayerMessagesToSend(){
		//# pp.setId(ihmGasp.aSID);
		//# pp.setPingNum(pp.getPingNum()+1);
	//#ifdef DEMO
		//# System.out.println("PingPlayer sent num: "+pp.getPingNum());
	//#endif DEMO
		//# return pp;
		//# 
	//# }
	//#endif PING
}
