/***
 * uGASP location based demonstrator.
 * Copyright (C) 2008 CNAM/INT
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contact: gasp-team@objectweb.org
 *
 * Author: Romain Pellerin
 */
//#include parameters.h
////////////////////////
// Compile params     //
////////////////////////



////////////////////////
// Game params        //
////////////////////////

////#define PING
////#define VIRTUAL_WORLD_MAP

////////////////////////
// Mobile Ajax params //
////////////////////////


////////////////////
// Logging params //
////////////////////

// enable to log in a mobile phone file (Nokia videos folder)
// we used the JSR75 
////#define LOG_FILE 


//#endinclude

//#ifdef GPS_SIMULATOR
package org.ugasp.location.simulator;
import java.io.DataInputStream;
import java.util.Vector;

import org.ugasp.demonstrator.client.IHMGasp;

public class GPSProvider implements Runnable {

	private Thread thread;
	private Listener listener;
	private Vector positions;
	
	public interface Listener {
	  	void fix(String utc, double lat, double lon, int nsat, double accuracy, double altitude);
	  	void failed(Throwable th);
	}
	
	public GPSProvider(IHMGasp ihm){
		System.out.println("GPSProvider");
		positions = new Vector();
		
		listener = (Listener) ihm;
		loadFile(ihm.aSID);
		
		
		thread = new Thread(this);
		thread.start();
	}

	private void loadFile(int id) {	
		try{
			System.out.println("Load file: "+"/gps"+id+".ugasp");
			DataInputStream dis = new DataInputStream(this.getClass().getResourceAsStream("/gps"+id+".ugasp"));
			
			String s = "";
			int index = 0;
		  	while(true){
	    		byte b = (byte) dis.read();
	    		//System.out.println("0.5 b:"+b);
	    		if (b == -1) break;
	    		
	    		s += (char) b;
	    		//data[index] = b;
	    		index++;
	    	}
		  	
		  	int _index = 0;
		  	
		  	while (true){
		  		int start = s.indexOf('\n',_index);
		  		if (start == -1) break;
		  		int end = s.indexOf('\n', start+1);

		  		parseCoordinates(s.substring(start+1, end));
		  		
		  		_index = end+1;
		  		if (_index >= s.length()) break;
		  	}
		}
		catch (Exception e){System.out.println("Could not load positions: "+e.getMessage());}
	}

	private void parseCoordinates(String s) {
		int start = 0;
		int end = s.indexOf(',',start);
		
		double lat = Double.parseDouble(s.substring(start, end));
		
		start = end+1;
		end = s.indexOf(',', start);
		start = end+1;
		end = s.indexOf(',', start);
		
		double lon = Double.parseDouble(s.substring(start, end));
		
		positions.addElement(new double[]{lat,lon});
		//System.out.println("add coord: "+lat+"/"+lon);
	}

	private long lastProvidingTime = 0;
	private static int providingDeltaTime = 500;
	private int currentPositionIndex = 0;
	private boolean invert = false;
	
	public void run() {
		while(true){
			try{
				if (!positions.isEmpty() && System.currentTimeMillis() > ((long) lastProvidingTime + providingDeltaTime)){
					double[] coords = (double[]) positions.elementAt(currentPositionIndex);
					listener.fix("", coords[0], coords[1], 0, 0.0, 0.0);
					
					if (invert) currentPositionIndex--;
					else currentPositionIndex++;
					
					if (!invert && currentPositionIndex == positions.size()){
						currentPositionIndex--;
						invert = true;
					}
					else if(invert && currentPositionIndex == 0 ){
						invert = false;
					}

					lastProvidingTime=System.currentTimeMillis();
				}
				else Thread.sleep(500);
				
				
			}
			catch(Exception e){
				System.out.println("Exception occured in GPSProvider run: "+e.getMessage());
			}
		}
	}
}
//#endif GPS_SIMULATOR
